

### Getting started on SPT:

### Install dependency:

We have tested our code on Torch 1.8.0, and 1.10.0. Please install the other dependencies with the following code at the home directory:

```
pip install -r requirements.txt
```

#### Data preparation:

We provide code for our main dataset VTAB-1k.

```
cd data/vtab-source
python get_vtab1k.py
```

PS: Manually install Sun397. Please also refer to [VTAB-1k](https://github.com/google-research/task_adaptation).

#### Getting pre-trained models:

Parameter-efficient training aims to tune a small number of parameters on top of the large pre-trained models. We provide demonstrates for two backbones: VIT-B/16 that is supervised trained and self-supervised trained with MAE pre-training strategy. Please download the backbones by the following code:

```
wget https://console.cloud.google.com/storage/browser/_details/vit_models/imagenet21k/ViT-B_16.npz
wget https://dl.fbaipublicfiles.com/mae/pretrain/mae_pretrain_vit_base.pth
```

#### Getting parameter sensitivity:

Our project has two stages; the first stage is to get the parameter sensitivity with the following code:

```
bash configs/vtab_supervised_spt_sensitivity.sh
bash configs/vtab_mae_spt_sensitivity.sh
```

Then, the second stage fine-tunes the sensitive connections or structured low-rank reparameterizations:

```
bash configs/vtab_supervised_spt_fine_tuning.sh
bash configs/vtab_mae_spt_fine_tuning.sh
```

