#!/usr/bin/env bash         \

set -x

currenttime=`date "+%Y%m%d_%H%M%S"`

PARTITION='dsta'
JOB_NAME=AD-VTAB
CONFIG=$1
GPUS=1
CKPT=$2
WEIGHT_DECAY=0.0001

GPUS_PER_NODE=1
CPUS_PER_TASK=5
SRUN_ARGS=${SRUN_ARGS:-""}

mkdir -p logs
PYTHONPATH="$(dirname $0)/..":$PYTHONPATH \

low_rank_dim=8
SEED=0

for LR in 0.001
do
    for GM in param_req_0.8 param_req_0.6 param_req_0.4 param_req_0.2
    do
      for DATASET in cifar caltech101 dtd oxford_flowers102 svhn sun397 oxford_iiit_pet patch_camelyon eurosat resisc45 diabetic_retinopathy clevr_count clevr_dist dmlab kitti dsprites_loc dsprites_ori smallnorb_azi smallnorb_ele
      do
          exp_name=vtab_spt_mae_ft
          export MASTER_PORT=$((12000 + $RANDOM % 20000))
          python train_spt.py --data-path=./data/vtab-1k/${DATASET} --data-set=${DATASET} --cfg=experiments/ViT-B_spt.yaml --resume=ViT-B_16.npz --output_dir=./saves/${DATASET}_lr-${LR}_wd-${WEIGHT_DECAY} --batch-size=64 --lr=${LR} --epochs=100 --weight-decay=${WEIGHT_DECAY} --no_aug --mixup=0 --cutmix=0 --direct_resize --smoothing=0 --launcher="none" --exp-name ${exp-name} --seed 0 --val_interval=10  --opt adamw --freeze_others="" --freeze_selected --low_rank_dim=${low_rank_dim} --sensitivity_path=sensitivity_vit/${DATASET}/${GM}.pth --scaler=spt_scaler --test | tee -a logs/${currenttime}-${exp_name}.log
      done
    done
done